// Made by Linux_Hat
#include "Car.h"
#include "MotorEncoder.h"
#define pi 3.1415

Car::Car(MotorEncoder* m1, MotorEncoder* m2, float distance) 
    : m_m1(m1), m_m2(m2), m_distance(distance) {
}

void Car::forward(float distance, double setPoint) { //distance : mm
    const float m1_mmp = pi*(*m_m1).m_radius*2/(*m_m1).m_ratio; // mm/pulse for m1
    const float m2_mmp = pi*(*m_m2).m_radius*2/(*m_m2).m_ratio; // mm/pulse for m2
    double m1_duration = 0;
    double m2_duration = 0;
    m_m1->setPoint = setPoint;
    m_m2->setPoint = setPoint/m2_mmp*m1_mmp;
    while(m1_duration<distance/m1_mmp && m2_duration<distance/m2_mmp) {
        if(m1_duration<distance/m1_mmp) {
            m1_duration+=m_m1->duration;
            m_m1->compute(0);
            m_m1->advance();
            m_m1->duration = 0;
        } else {m_m1->stop();}
        if(m2_duration<distance/m2_mmp) {
            m2_duration+=m_m2->duration;
            m_m2->compute(0);
            m_m2->advance();
            m_m2->duration = 0;
        } else {m_m2->stop();}
    }
    m_m1->stop();
    m_m2->stop();
}

void Car::turn(float angle, double setPoint) { //angle : degre
    float distance = pi*m_distance/360*angle;
    const float m1_mmp = pi*(*m_m1).m_radius*2/(*m_m1).m_ratio; // mm/pulse for m1
    const float m2_mmp = pi*(*m_m2).m_radius*2/(*m_m2).m_ratio; // mm/pulse for m2
    double m1_duration = 0;
    double m2_duration = 0;
    m_m1->setPoint = setPoint;
    m_m2->setPoint = setPoint/m2_mmp*m1_mmp;
    boolean m1_tmp = false;
    boolean m2_tmp = false;
    if(angle>0) {
        while(!m1_tmp && !m2_tmp) {
            if(m1_duration<distance/m1_mmp) {
//                Serial.print("M1 cycle ");
//                Serial.print(m1_duration);
//                Serial.print("  ");
//                Serial.println(m_m1->duration);
                m1_duration+=m_m1->duration;
                m_m1->compute(0);
                m_m1->advance();
                m_m1->duration = 0;
            } else {m1_tmp = true; m_m1->stop();}
            if(m2_duration<distance/m2_mmp) {
//                Serial.print("M2 cycle ");
//                Serial.print(m2_duration);
//                Serial.print("  ");
//                Serial.println(m_m2->duration);
                m2_duration-=m_m2->duration;
                m_m2->compute(0);
                m_m2->back();
                m_m2->duration = 0;
            } else {m2_tmp = true; m_m2->stop();}
        }
    } else if(angle<0) {
        while(!m1_tmp && !m2_tmp) {
            if(m1_duration<distance/m1_mmp) {
                m1_duration-=m_m1->duration;
                m_m1->compute(0);
                m_m1->back();
                m_m1->duration = 0;
            } else {m1_tmp = true; m_m1->stop();}
            if(m2_duration<distance/m2_mmp) {
                m2_duration+=m_m2->duration;
                m_m2->compute(0);
                m_m2->advance();
                m_m2->duration = 0;
            } else {m2_tmp = true; m_m2->stop();}
        }
    }
    Serial.println(m1_tmp);
    Serial.println("End");
    m_m1->stop();
    m_m2->stop();
}