// Made by Linux_Hat
#pragma once
#include <PID_v1.h>
#include <Arduino.h>

class MotorEncoder {
    private:
        uint8_t encoder0PinALast; //the number of the pulses
        boolean m_orientation; //the rotation orientation
        boolean result;
        PID* myPID;
        double val_output; //Power supplied to the motor PWM value.
        double Kp = 0.6, Ki = 5, Kd = 0;
        uint8_t m_encoder0pinA; //A pin
        uint8_t m_encoder0pinB; //B pin 
        int m_E_left; //The enabling of L298PDC motor driver board connection to the digital interface port 5
        int m_M_left;
        double abs_duration;

    public:
        double setPoint;
        float m_ratio; // how many pulse for a complete turn
        float m_radius; // wheel radius in mm
        double duration;

        MotorEncoder(uint8_t encoder0pinA, uint8_t encoder0pinB, int E_left, int M_left, boolean orientation, float ratio, float radius);

        void EncoderHandlerInit(void (*ISR)(void));
        void wheelSpeed();
        void advance();
        void back();
        void stop();
        void compute(int debug);
};