#include <RF24.h>
#include <SPI.h>
#include <Arduino.h>
#include "radio.h"

Radio::Radio(int canal, int pinCE, int pinCSN) {
    m_canal = canal;
    m_pinCE = pinCE;
    m_pinCSN = pinCSN;
    radio = new RF24(pinCE, pinCSN);
    if (!radio->begin()) {
        Serial.println("Error while initialise the NRF module");
        while (1); 
    }
    Serial.println("Module initialised");
    radio->openReadingPipe(0, adresse);
    radio->setChannel(canal); 
    radio->setPALevel(RF24_PA_MIN); 
    radio->startListening();
}

char Radio::read() {
    if (radio->available()) {
        radio->read(&message, sizeof(message));
        return *message;
    }
}